#ifndef bsqw_input_hh
#define bsqw_input_hh

#include "sizes.h"

#include <string>
#include <list>

#include "inputevent.hh"
#include "inputfield.hh"
#include "inputdev.hh"

class InputGroup
{
    typedef autoptr<InputField> fieldptr;
    list<fieldptr> inputs;
    bool finished;

    void onetick();
    enum {st0=0, stLiteral} state;
    string keystr;
    unsigned alt;
    
    void Submit(InputEvent ev);
    
public:
    InputGroup();
    ~InputGroup();
    
    void operator+= (fieldptr input);
    
    void run();
    bool tick();
    inline bool done() const { return finished; }
};

#endif
